/*
FILE: task_oneshot.c
COPYRIGHT (C) 2008    Claudio Aciti (caciti@exa.unicen.edu.ar)
This library is free software; you can redistribute it and/or modify it
   under the terms of the GNU Lesser General Public License as published
   by the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.
This library is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
   Lesser General Public License for more details.
You should have received a copy of the GNU Lesser General Public License
   along with this library; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
   USA.
*/

#include <linux/module.h>
#include <asm/io.h>
#include <rtai.h>
#include <rtai_sched.h>
#include <rtai_fifos.h>

/*definicion del periodo del temporizador en nanosegundos*/
#define TIMERTICKS 500000

/*definicion del modo de operacion del reloj. Puede ser ONE_SHOT o PERIODIC_MODE*/
#define ONE_SHOT /*no es periodico :P. Hay que reprogramarla cada vez para que produzca la siguiente interrupcion*/


/*declaracion de las tareas*/
static RT_TASK Task0, Task1, Task2, Task3, Task4, Task5, Task6, Task7, Task8, Task9;

/**/
static int cpu_used[NR_RT_CPUS];


static void print(long arg)
{
  printk("Tarea %d \n",rt_whoami());
}

int init_module(void)
{
  RTIME tick_period;
  RTIME now;

/*inicia tarea: estructura, funcion , integer parametro a la tarea, stack size de la tarea, prioridad, uso de FPU, puntero a manejador de funciones*/
rt_task_init(&Task0, print, 0, 2000, 0, 0, 0);
rt_task_init(&Task1, print, 0, 2000, 0, 0, 0);
rt_task_init(&Task2, print, 0, 2000, 0, 0, 0);
rt_task_init(&Task3, print, 0, 2000, 0, 0, 0);
rt_task_init(&Task4, print, 0, 2000, 0, 0, 0);
rt_task_init(&Task5, print, 0, 2000, 0, 0, 0);
rt_task_init(&Task6, print, 0, 2000, 0, 0, 0);
rt_task_init(&Task7, print, 0, 2000, 0, 0, 0);
rt_task_init(&Task8, print, 0, 2000, 0, 0, 0);
rt_task_init(&Task9, print, 0, 2000, 0, 0, 0);

#ifdef ONE_SHOT
rt_set_oneshot_mode();
#endif

tick_period = 4*start_rt_timer(nano2count(TIMERTICKS));

now = rt_get_time();
/*puntero a la estructura, inicio, periodo*/ 
rt_task_make_periodic(&Task0, now + tick_period, tick_period);
rt_task_make_periodic(&Task1, now + tick_period, tick_period);
rt_task_make_periodic(&Task2, now + tick_period, tick_period);
rt_task_make_periodic(&Task3, now + tick_period, tick_period);
rt_task_make_periodic(&Task4, now + tick_period, tick_period);
rt_task_make_periodic(&Task5, now + tick_period, tick_period);
rt_task_make_periodic(&Task6, now + tick_period, tick_period);
rt_task_make_periodic(&Task7, now + tick_period, tick_period);
rt_task_make_periodic(&Task8, now + tick_period, tick_period);
rt_task_make_periodic(&Task9, now + tick_period, tick_period);
return 0;
}

void cleanup_module(void)
{
 stop_rt_timer();
 rt_task_delete(&Task0);
 rt_task_delete(&Task1);
 rt_task_delete(&Task2);
 rt_task_delete(&Task3);
 rt_task_delete(&Task4);
 rt_task_delete(&Task5);
 rt_task_delete(&Task6);
 rt_task_delete(&Task7);
 rt_task_delete(&Task8);
 rt_task_delete(&Task9);
}

